/* Retorna a conta contbil do produto */

CREATE OR REPLACE FUNCTION USR_CONTCTBL_PROD
   (P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_CDPRODUTO  IN PRODUTO.CDPRODUTO%TYPE,
    P_CDARVPROD  IN PRODUTO.CDARVPROD%TYPE,
    P_TIPO       IN NOTAFISCAL.IDENTRSAIDOP%TYPE)
RETURN VARCHAR
AS
   V_IDENTRSAIDOP VARCHAR2(01);
   V_CDTIPOOPER   VARCHAR2(02);
   V_CDFILIAL     VARCHAR2(04);
   V_CDCONTCTBL   VARCHAR2(20);
   V_CDCONTREDU   VARCHAR2(20);
   V_CDARVPROD    VARCHAR2(20);
BEGIN
   SELECT MAX(IDENTRSAIDOP), MAX(CDTIPOOPER),
          MAX(DECODE(IDENTRSAIDOP, 'E', CDFILIRECE, CDFILIEMIT))
   INTO V_IDENTRSAIDOP, V_CDTIPOOPER, V_CDFILIAL
   FROM NOTAFISCAL
   WHERE CDFILIAL   = P_CDFILIAL AND
         NRLANCTONF = P_NRLANCTONF;

   IF P_TIPO = 'C' THEN
      SELECT MAX(CDCTBLCPROPF)
      INTO V_CDCONTCTBL
      FROM PRODFILI
      WHERE CDFILIAL  = V_CDFILIAL AND
            CDPRODUTO = P_CDPRODUTO;

      IF V_CDCONTCTBL IS NULL THEN
         SELECT MAX(CDARVPROD)
         INTO V_CDARVPROD
         FROM PRODUTO
         WHERE P_CDARVPROD LIKE CDARVPROD || '%' AND
               CDCTBLCPROPR IS NOT NULL;

         SELECT MAX(CDCTBLCPROPR)
         INTO V_CDCONTCTBL
         FROM PRODUTO
         WHERE CDARVPROD = V_CDARVPROD;
      END IF;
   END IF;

   IF P_TIPO = 'T' THEN
      SELECT MAX(CDCTBLPRODPF)
      INTO V_CDCONTCTBL
      FROM PRODFILI
      WHERE CDFILIAL  = V_CDFILIAL AND
            CDPRODUTO = P_CDPRODUTO;

      IF V_CDCONTCTBL IS NULL THEN
         SELECT MAX(CDARVPROD)
         INTO V_CDARVPROD
         FROM PRODUTO
         WHERE P_CDARVPROD LIKE CDARVPROD || '%' AND
               CDCTBLPRODPR IS NOT NULL;

         SELECT MAX(CDCTBLPRODPR)
         INTO V_CDCONTCTBL
         FROM PRODUTO
         WHERE CDARVPROD = V_CDARVPROD;
      END IF;
   END IF;

   IF (P_TIPO = 'R') THEN
      SELECT MAX(CDCTBLCPROPF)
      INTO V_CDCONTCTBL
      FROM PRODFILI
      WHERE CDFILIAL  = V_CDFILIAL AND
            CDPRODUTO = P_CDPRODUTO;

      IF V_CDCONTCTBL IS NULL THEN
         SELECT MAX(CDARVPROD)
         INTO V_CDARVPROD
         FROM PRODUTO
         WHERE P_CDARVPROD LIKE CDARVPROD || '%' AND
               CDCTBLCPROPR IS NOT NULL;

         SELECT MAX(CDCTBLCPROPR)
         INTO V_CDCONTCTBL
         FROM PRODUTO
         WHERE CDARVPROD = V_CDARVPROD;
      END IF;
   END IF;

   IF V_CDCONTCTBL IS NULL THEN
      SELECT MAX(CDCONTPROD)
      INTO V_CDCONTCTBL
      FROM TIPOOPERAC
      WHERE IDENTRSAIDOP = V_IDENTRSAIDOP AND
            CDTIPOOPER   = V_CDTIPOOPER;
   END IF;

   IF V_CDCONTCTBL IS NULL THEN
      SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCTBLENTRPF, CDCTBLSAIDPF))
      INTO V_CDCONTCTBL
      FROM PRODFILI
      WHERE CDFILIAL  = V_CDFILIAL AND
            CDPRODUTO = P_CDPRODUTO;

      IF V_CDCONTCTBL IS NULL THEN
         SELECT MAX(CDARVPROD)
         INTO V_CDARVPROD
         FROM PRODUTO
         WHERE P_CDARVPROD LIKE CDARVPROD || '%' AND
               DECODE(V_IDENTRSAIDOP, 'E', CDCTBLENTRPR, CDCTBLSAIDPR) IS NOT NULL;

         SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCTBLENTRPR, CDCTBLSAIDPR))
         INTO V_CDCONTCTBL
         FROM PRODUTO
         WHERE CDARVPROD = V_CDARVPROD;
      END IF;
   END IF;

   SELECT MAX(CDCONTREDU)
   INTO V_CDCONTREDU
   FROM CONTCTBL
   WHERE CDCONTCTBL = V_CDCONTCTBL;

   IF V_CDCONTREDU IS NULL THEN
      RETURN(V_CDCONTCTBL);
   ELSE
      RETURN(V_CDCONTREDU);
   END IF;
END;
/


/* Retorna a conta contbil do imposto */

CREATE OR REPLACE FUNCTION USR_CONTCTBL_IMPOSTO
    (P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
    P_CDIMPOSTO  IN IMPOSTO.CDIMPOSTO%TYPE)
RETURN VARCHAR
AS
   V_IDENTRSAIDOP VARCHAR2(01);
   V_CDTIPOOPER   VARCHAR2(02);
   V_CDCONTCTBL   VARCHAR2(20);
   V_CDCONTREDU   VARCHAR2(20);
BEGIN
   SELECT MAX(IDENTRSAIDOP), MAX(CDTIPOOPER)
   INTO V_IDENTRSAIDOP, V_CDTIPOOPER
   FROM NOTAFISCAL
   WHERE CDFILIAL   = P_CDFILIAL AND
         NRLANCTONF = P_NRLANCTONF;

   SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCCTBATIVTO, CDCCTBPASSTO))
   INTO V_CDCONTCTBL
   FROM CTBIMPTPOPER
   WHERE IDENTRSAIDOP = V_IDENTRSAIDOP AND
         CDTIPOOPER   = V_CDTIPOOPER   AND
         CDIMPOSTO    = P_CDIMPOSTO;

   IF V_CDCONTCTBL IS NULL THEN
      SELECT MAX(DECODE(V_IDENTRSAIDOP, 'E', CDCCTBLATIV, CDCCTBLPASS))
      INTO V_CDCONTCTBL
      FROM IMPOSTO
      WHERE CDIMPOSTO    = P_CDIMPOSTO;
   END IF;

   SELECT MAX(CDCONTREDU)
   INTO V_CDCONTREDU
   FROM CONTCTBL
   WHERE CDCONTCTBL = V_CDCONTCTBL;

   IF V_CDCONTREDU IS NULL THEN
      RETURN(V_CDCONTCTBL);
   ELSE
      RETURN(V_CDCONTREDU);
   END IF;
END;
/


/* Retorna os dados adicionais da Nota Fiscal de forma agrupada */

CREATE OR REPLACE FUNCTION USR_DSDADOSADIC
   (P_CDFILIAL   IN NOTAFISCAL.CDFILIAL%TYPE,
    P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE)
RETURN VARCHAR
AS
   V_AUXILIAR VARCHAR2(2000);
BEGIN
   V_AUXILIAR := 'General';
   FOR C_DADOSADIC IN (SELECT DSDADOADIC
                       FROM DADOSADIC
                       WHERE CDFILIAL   = P_CDFILIAL AND
                             NRLANCTONF = P_NRLANCTONF
                       ORDER BY NRDADOADIC) LOOP
      IF V_AUXILIAR = 'General' THEN
         V_AUXILIAR := C_DADOSADIC.DSDADOADIC;
      ELSE
         V_AUXILIAR := CHR(10) || V_AUXILIAR || C_DADOSADIC.DSDADOADIC;
      END IF;
   END LOOP;
   RETURN(V_AUXILIAR);
END;
/


/* Retorna o valor contbil da nota fiscal */

CREATE OR REPLACE FUNCTION USR_VALOR_CONTABIL(
   P_CDFILIAL    IN ITEMPRODUTO.CDFILIAL%TYPE,
   P_NRLANCTONF  IN ITEMPRODUTO.NRLANCTONF%TYPE,
   P_NRSEQITPROD IN ITEMPRODUTO.NRSEQITPROD%TYPE)

RETURN NUMBER
IS
   V_VRCONTITEM  NUMBER;
   V_VRNOTAFISC  NUMBER;
   V_VRIMPOSTONF NUMBER;
   V_VRIMPOSTOT  NUMBER;
   V_DIFERENCA   NUMBER;
   V_NRSEQITPROD ITEMPRODUTO.NRSEQITPROD%TYPE;
BEGIN
   SELECT MIN(NRSEQITPROD)
   INTO V_NRSEQITPROD
   FROM ITEMPRODUTO
   WHERE CDFILIAL   = P_CDFILIAL
     AND NRLANCTONF = P_NRLANCTONF;

   IF P_NRSEQITPROD = V_NRSEQITPROD THEN
      V_VRCONTITEM := 0;
      FOR C_VRCONTITEM IN (SELECT USR_CONTCTBL_PROD(I.CDFILIAL, I.NRLANCTONF, P.CDPRODUTO, P.CDARVPROD, 'E') AS CDCONTPROD,
                                  NVL(ROUND(SUM(I.VRCONTITEM),2),0) AS VRCONTITEM
                           FROM ITEMPRODUTO I, PRODUTO P
                           WHERE I.CDFILIAL   = P_CDFILIAL
                             AND I.NRLANCTONF = P_NRLANCTONF
                             AND I.CDPRODUTO  = P.CDPRODUTO
                           GROUP BY USR_CONTCTBL_PROD(I.CDFILIAL, I.NRLANCTONF, P.CDPRODUTO, P.CDARVPROD,'E')) LOOP

         V_VRCONTITEM := V_VRCONTITEM + C_VRCONTITEM.VRCONTITEM;
      END LOOP;

      SELECT NVL(ROUND(SUM(VRNOTAFISC),2),0)
      INTO V_VRNOTAFISC
      FROM NOTAFISCAL
      WHERE CDFILIAL   = P_CDFILIAL
        AND NRLANCTONF = P_NRLANCTONF;

      SELECT NVL(SUM(ROUND(VRIMPOSTOIT,2)),0)
      INTO V_VRIMPOSTONF
      FROM ITEMPROIMPOS II
      WHERE CDFILIAL   = P_CDFILIAL
        AND NRLANCTONF = P_NRLANCTONF
        AND USR_CONTCTBL_IMPOSTO(II.CDFILIAL, II.NRLANCTONF, II.CDIMPOSTO) IS NOT NULL;

      SELECT NVL(SUM(ROUND(VRTOTIMPONF,2)),0)
      INTO V_VRIMPOSTOT
      FROM IMPOSNFTOT I, IMPOSTO IP
      WHERE I.CDFILIAL    = P_CDFILIAL
        AND I.NRLANCTONF  = P_NRLANCTONF
        AND I.CDIMPOSTO   = IP.CDIMPOSTO
        AND IP.IDPRODNOTA = 'C'
        AND USR_CONTCTBL_IMPOSTO(I.CDFILIAL, I.NRLANCTONF, I.CDIMPOSTO) IS NOT NULL;

      V_DIFERENCA := ((V_VRCONTITEM + V_VRIMPOSTONF + V_VRIMPOSTOT) - (V_VRNOTAFISC));

      IF ABS(V_DIFERENCA) <= 0.02 THEN
         SELECT NVL(SUM(VRCONTITEM),0)
         INTO V_VRCONTITEM
         FROM ITEMPRODUTO
         WHERE CDFILIAL    = P_CDFILIAL
           AND NRLANCTONF  = P_NRLANCTONF
           AND NRSEQITPROD = P_NRSEQITPROD;

         V_VRCONTITEM := V_VRCONTITEM - V_DIFERENCA;
      END IF;
   ELSE
      SELECT NVL(SUM(VRCONTITEM),0)
      INTO V_VRCONTITEM
      FROM ITEMPRODUTO
      WHERE CDFILIAL    = P_CDFILIAL
        AND NRLANCTONF  = P_NRLANCTONF
        AND NRSEQITPROD = P_NRSEQITPROD;
   END IF;

   RETURN(V_VRCONTITEM);
END;
/


/* Criao da tabela USR_SKYLCONTNFE */
create table USR_SKYLCONTNFE 
( CDFILIAL    VARCHAR2(4)      NOT NULL,
  NRLANCTONF  VARCHAR2(10)     NOT NULL,
  CDSEQNF     INT              NOT NULL,
  DSARQUIVO   VARCHAR2(2000)   NOT NULL 
)
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_VALOR_CONTABIL','5.01.001'); END;
/

